%define nx_name nx_nic
%define nx_version 3.4.336
%define nx_release 1

Summary: NetXen driver for NIC.
Name: %{nx_name}
Version: %{nx_version}
Release: %{nx_release}
Source: %{name}-%{version}.tar.gz
Vendor: NetXen, Inc.
License: GPL
Group: System Environment/Kernel
Provides: %{name}
URL: http://www.netxen.com
Requires: kernel, bash
Buildroot: %{_tmppath}/%{name}-%{version}/bldroot

%define files_list %{_builddir}/%{name}-%{version}/files.list
%define kernel %(uname -r)
%define exec_script /usr/bin/nx_snmp.pl
%define mpc1 %(ls -1 /etc/modprobe.conf.local 2> /dev/null)
%define mpc2 %(ls -1 /etc/modprobe.conf 2> /dev/null)
%define mpc3 %(ls -1 /etc/modules.conf 2> /dev/null)
%define modprobe_conf %(echo "%{mpc1},%{mpc2},%{mpc3}" | sed -e "s/^,*//" -e "s/,.*//")
%define netxen_driver /lib/modules/%{kernel}/kernel/drivers/net/netxen/netxen_nic.ko
%define blacklist_entry %(echo "blacklist netxen_nic")
%define snmpd_conf /etc/snmp/snmpd.conf
%define mid_obj_id .1.3.6.1.2.1.10.7.11.1
%define pass_entry %(echo "pass %{mid_obj_id} %{exec_script}")

%define debug_package %{nil}

%description
This package contains the Linux driver for the NetXen's NIC.

%prep
%setup -q

%build
make rpm_build=1

%install
DIR_LIST="/lib/firmware/%{kernel}"
DIR_LIST="$DIR_LIST /lib/modules/%{kernel}/kernel/drivers/net"
DIR_LIST="$DIR_LIST /usr/bin /usr/lib/hotplug/firmware /usr/local/bin"
DIR_LIST="$DIR_LIST /usr/local/man/man4 /usr/man/man4 /usr/share/man/man4"
EXEC_SCRIPT=$RPM_BUILD_ROOT%{exec_script}
rm -rf $RPM_BUILD_ROOT
for dir in $DIR_LIST; do
    mkdir -p $RPM_BUILD_ROOT$dir
done
cp -f $(basename $EXEC_SCRIPT) $EXEC_SCRIPT
make PREFIX=$RPM_BUILD_ROOT install
find $RPM_BUILD_ROOT -type f -print | \
    sed -e "s#^$RPM_BUILD_ROOT##" -e "/^\/usr.*\/man\//s/\(.*\)/%doc \1/" \
    > %{files_list}

%files -f %{files_list}
%defattr(-,root,root)

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -f %{netxen_driver} ]; then
    if ! (grep "%{blacklist_entry}" %{modprobe_conf} > /dev/null); then
        cp %{modprobe_conf} %{modprobe_conf}.saved
        echo "%{blacklist_entry}" >> %{modprobe_conf}
    fi
fi
depmod -a
if [ -f %{snmpd_conf} ]; then
    if ! (grep "%{pass_entry}" %{snmpd_conf} > /dev/null); then
        cp %{snmpd_conf} %{snmpd_conf}.saved
        echo "%{pass_entry}" >> %{snmpd_conf}
    fi
fi

%postun
if [ -f %{netxen_driver} ]; then
    grep -v "%{blacklist_entry}" %{modprobe_conf} > %{modprobe_conf}.tmp$$
    mv %{modprobe_conf}.tmp$$ %{modprobe_conf}
fi
depmod -a
if [ -f %{snmpd_conf} ]; then
    grep -v "%{pass_entry}" %{snmpd_conf} > %{snmpd_conf}.tmp$$
    mv %{snmpd_conf}.tmp$$ %{snmpd_conf}
fi
