summary     	: OpenIPMI +HP
name        	: hp-OpenIPMI
Version		:        8.1.0
Release		:        104.rhel4
group       	: System Environment/Kernel
source		: hp-OpenIPMI.tar.gz
license		: GNU Public License
packager    	: Hewlett-Packard Company
vendor		: Hewlett-Packard Company
url         	: http://www.hp.com/go/proliantlinux
buildroot   	: /var/tmp/%{name}
icon		: hprpm.xpm
autoreqprov	: no
prereq		: /bin/sh, /bin/bash

%description
This is an upgraded version of the Open IPMI device driver that is shipped as part of the standard Linux kernel. This release is for Linux 2.6 kernels. This provides support for PCI Based Base Management Controllers that are truly interrupt driven. This package will NOT activate on it's own.  The drivers for this release are place in the /opt/hp/hp-OpenIPMI/bin with a script that can be used to launch the IPMI drivers.  This has been done as the changes made to the IPMI drivers are expected to be included in future Linux kernels.

The hp-OpenIPMI driver can be built for any kernel like any other GPL Open Source application.  You need to load the appropriate kernel-devel (for Red Hat releases) package to do this.

%prep
%setup -n %{name}

%build
EFS_VER=%{version}\-%{release}
PKG_VER=%{version}\-CUSTOM
echo "$PKG_VER" > PKG_VERSION
make -f hp-OpenIPMI.mk OS_MODEL=LINUX EFS_VER="$EFS_VER" all

%pre
BUSY=`lsmod |fgrep ipmi_msghandler`
if [ ${#BUSY} -ne 0 ]; then
	echo "There is an existing IPMI driver already loading on this system:"
	echo " ---  ${BUSY}"
	echo "Please disable or remove ${BUSY} after loading "
	echo "this package to avoid potential conflicts."
	echo "NOTE:  Unloading current IPMI driver if possible."

	rmmod ipmi_si
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_si!"
		echo "Please remove the installed 'ipmi' modules and disable"
		echo "the initialization scripts."
		exit 1
	fi

	rmmod ipmi_devintf
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_devintf!"
		echo "Please remove the installed 'ipmi' modules and disable"
		echo "the initialization scripts."
		exit 1
	fi

	rmmod ipmi_msghandler
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_msghandler!"
		echo "Please remove the installed 'ipmi' modules and disable"
		echo "the initialization scripts."
		exit 1
	fi
fi
exit 0


%install
if [ $RPM_BUILD_ROOT != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

mkdir -p $RPM_BUILD_ROOT

export RPM_BUILD_ROOT
export RPM_MAKE_ROOT=.
export RPM_NAME=%{name}

make -f hp-OpenIPMI.mk install


%post
sync
#
# Let's see if we need to rebuild
#

sh /opt/hp/hp-OpenIPMI/check_install_kernel.sh

#
# Display EULA for Source Modules
#
echo "Please read the Licence Agreement for this software at"
echo
echo "         /opt/hp/hp-OpenIPMI/COPYING"
echo "                       and"
echo "         /opt/hp/hp-OpenIPMI/hp-OpenIPMI.license"
echo
echo "By not removing this package, you are accepting the terms"
echo "of the included licenses."
echo ""
echo "The man page, hp-OpenIPMI(4), describes how to enable and use"
echo "the hp-OpenIPMI device drivers."
exit 0

%preun
sync
#
# We might be upgrading which in that case, we really do
# not want to do this.
#

BUSY=`lsmod |fgrep ipmi_si`
if [ ${#BUSY} -ne 0 ]; then
	rmmod ipmi_si
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_si!"
		echo "Make sure all applications using the IPMI interface"
		echo "have been terminated before removing this package."
		exit 1
	fi
fi

BUSY=`lsmod |fgrep ipmi_devintf`
if [ ${#BUSY} -ne 0 ]; then
	rmmod ipmi_devintf
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_devintf!"
		echo "Make sure all applications using the IPMI interface"
		echo "have been terminated before removing this package."
		exit 1
	fi
fi

BUSY=`lsmod |fgrep ipmi_msghandler`
if [ ${#BUSY} -ne 0 ]; then
	rmmod ipmi_msghandler
	if [ $? != 0 ]; then
		echo "Unable to remove module ipmi_msghandler!"
		echo "Make sure all applications using the IPMI interface"
		echo "have been terminated before removing this package."
		exit 1
	fi
fi

# We might be upgrading which in that case, we really do not want to do this.
if [ $1 -eq 0 ]; then
	if [ -f /opt/hp/hp-OpenIPMI/Makefile ]; then
		cd /opt/hp/hp-OpenIPMI
		make clean
		cd
	fi
fi

exit 0

%postun
sync
# We might be upgrading which in that case, we really do not want to do this.
if [ $1 -eq 0 ]; then
	rm -rf /opt/hp/hp-OpenIPMI
	echo "The hp-OpenIPMI package has been removed from this system"
	rm -f  /var/lock/subsys/hp-OpenIPMI
	echo -e "\n"
fi
exit 0

%clean
rm -fR $RPM_BUILD_ROOT

%files 
%defattr(700,root,root)
/opt/hp/hp-OpenIPMI
%defattr(644,root,root)
/usr/share/man/man4/hp-OpenIPMI.4.gz

